<?php

namespace Edeclic\PrestashopBridgeBundle\DependencyInjection;

use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\Config\FileLocator;
use Symfony\Component\HttpKernel\DependencyInjection\Extension;
use Symfony\Component\DependencyInjection\Loader;

/**
 * This is the class that loads and manages your bundle configuration.
 *
 * @link http://symfony.com/doc/current/cookbook/bundles/extension.html
 */
class EdeclicPrestashopBridgeExtension extends Extension
{
    /**
     * {@inheritdoc}
     */
    public function load(array $configs, ContainerBuilder $container)
    {
        //Process Configuration
        $configuration = new Configuration();
        $config = $this->processConfiguration($configuration, $configs);

        //Load conf file
        $loader = new Loader\YamlFileLoader($container, new FileLocator(__DIR__ . '/../Resources/config'));
        $loader->load('services.yml');

        //Inject configuration in services
        $prestaServiceDefinition = $container->getDefinition('edeclic.prestashop.bridge');
        $prestaServiceDefinition->addMethodCall('setConfig', array($config['prestashop']));

        $prestaLogoutDefinition = $container->getDefinition('edeclic.prestashop.logout');
        $prestaLogoutDefinition->addMethodCall('setConfig', array($config['prestashop']));
    }
}
